package cn.estsh.i3plus.ext.mes.pcn.api.busi.spot;

import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesSpotCheckOrderModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesSpotCheckOrder;
import cn.estsh.i3plus.pojo.mes.bean.MesSpotCheckOrderPart;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author :
 * @CreateDate : 2024-04-26 15:37
 * @Modify:
 **/
public interface IMesSpotCheckOrderService {

    /**
     * 、
     * 查询点检单
     *
     * @param spotCheckOrder
     * @param pager
     * @return
     */
    @ApiOperation("查询点检单")
    ListPager<MesSpotCheckOrder> querySpotCheckOrder(MesSpotCheckOrder spotCheckOrder, Pager pager);


    /**
     * 查询点检单明细
     *
     * @param spotCheckOrder
     * @return
     */
    @ApiOperation("查询点检单明细")
    MesSpotCheckOrderModel querySpotCheckOrderResult(MesSpotCheckOrder spotCheckOrder);

    /**
     * 扫描产品条码
     *
     * @param model
     * @param org
     * @return
     */
    @ApiOperation("扫描产品条码")
    MesSpotCheckOrderModel scanProduceSn(MesSpotCheckOrderModel model, String org);

    /**
     * 开始点检-查询设备数据
     *
     * @param model
     * @param org
     * @return
     */
    @ApiOperation("开始点检-查询设备数据")
    MesSpotCheckOrderModel queryEquipInfo(MesSpotCheckOrderModel model, String org);

    /**
     * 开始点检-查询设备数据
     *
     * @param model
     * @param org
     * @return
     */
    @ApiOperation("完成点检")
    void saveCheck(MesSpotCheckOrderModel model, String org);

    /**
     * 开始点检-查询设备数据
     *
     * @param model
     * @param org
     * @return
     */
    @ApiOperation("重新点检")
    void saveReCheck(MesSpotCheckOrderModel model, String org);


}
