package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesJisShippingService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesJisShipping;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesShippingOrderManagement;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesShippingOrderManagementDetail;
import cn.estsh.i3plus.pojo.mes.repository.MesShippingOrderManagementDetailRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesShippingOrderManagementRepository;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author :
 * @CreateDate : 2024-05-10 14:38
 * @Modify:
 **/
@Service
@Slf4j
public class MesJisShippingService implements IMesJisShippingService {

    @Autowired
    private MesShippingOrderManagementRepository shippingOrderManagementRepository;
    @Autowired
    private MesShippingOrderManagementDetailRepository shippingOrderManagementDetailRepository;

    public List<MesJisShipping> getJisShipping(List<MesShippingOrderManagementDetail> orderManagementDetailList, String org) {


        DdlPackBean packBean = DdlPackBean.getDdlPackBean(org);
        DdlPreparedPack.getStringEqualPack(orderManagementDetailList.get(0).getLoadingOrderNo(), "shippingCode", packBean);
        MesShippingOrderManagement originBean = shippingOrderManagementRepository.getByProperty(packBean);

        DdlPackBean detailPackBean = DdlPackBean.getDdlPackBean(org);
        DdlPreparedPack.getStringEqualPack(originBean.getShippingCode(), "shippingCode", detailPackBean);
        List<MesShippingOrderManagementDetail> detailDeleteList = shippingOrderManagementDetailRepository.findByHqlWhere(detailPackBean);

        List<MesJisShipping> jisShippingList = new ArrayList<>();
        orderManagementDetailList.forEach(k -> {
            MesJisShipping jisShipping = new MesJisShipping();
            BeanUtils.copyProperties(originBean, jisShipping, "id");
            BeanUtils.copyProperties(k, jisShipping, "id");
            jisShipping.setFactoryCode(originBean.getCustOrganizeCode());
            jisShipping.setShippingTime(TimeTool.getNowTime(true));
            jisShipping.setDock(originBean.getSendDockCode());
            jisShipping.setCusDock(originBean.getCustDockCode());
            jisShipping.setCustOrderNo(k.getCustOrderNo());
            jisShipping.setSerialNumber(k.getBarcode());
            jisShipping.setQuantityPerCar(detailDeleteList.size());
            jisShipping.setShippingOrderCode(originBean.getShippingCode());
            ConvertBean.serviceModelInitialize(jisShipping, AuthUtil.getSessionUser().getUserName());
            jisShippingList.add(jisShipping);
        });

        return jisShippingList;
    }
}
